<template>
  <div class="container">
    <h2>New Stat</h2>
    <b-form-input
      v-for="st in stat_list"
      :key="st"
      v-model="inp[st]"
      required
      :placeholder="st"
      type="number">
    </b-form-input>
    <div class="buttons">
      <b-button-group>
        <b-button 
          variant="success"
          @click="submit"
          :disabled="!valid">Submit</b-button>
        <b-button 
          variant="danger"
          @click="cancel">Cancel</b-button>
      </b-button-group>
    </div>
  </div>
</template>

<script>
export default {
  data() {
    return {
      stat_list: ['hp','mp','ap','str','def','dex','int','luk','agi'],
      inp: {
        hp: '',
        mp: '',
        ap: '',
        str: '',
        def: '',
        dex: '',
        int: '',
        luk: '',
        agi: ''
      },
      error: ''
    };
  },
  computed: {
    valid() {
      let prod = 1;

      for (let st of this.stat_list) {
        console.log(`${st}: ${this.inp[st]}`);
        prod *= this.inp[st];
      }
      
      return prod > 0;
    }
  },
  methods: {
    submit() {
      let data = {
        stat: this.inp
      },
      ins = this;

      this.error = '';

      this.$axios({
        method: 'post',
        url: 'http://localhost:3000/stats',
        data: data
      })
        .then(res => {
          ins.$router.go();
        })
        .catch(err => {
          ins.error = 'Ocorreu um erro... :(';
        })
    },
    cancel() {
      this.name = '';
      this.cost = '';
    }
  }
}
</script>

<style>
.container {
  max-width: 35vw;
  border: 0.2rem solid lightgray;
  border-radius: 10px;
  padding: 1rem;
}

.buttons {
  display: flex;
  justify-content: center;
}
</style>
